/* simplestring.h
 * ------------------------------------------------------------------------
 *
 * Copyright (C) 2000 Matthew Stanton <matthews@softhome.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * ------------------------------------------------------------------------
 *
 */

#include <math.h>
#include <stdio.h>

#define SAMPLE_RATE 44100.0
#define BUFFER_SIZE 4096	// lowest frequency 10.7 Hz at 44100 kHz samplerate

class SimpleString : public OX_Machine {
private:
	enum {
		ix_note					= 0,
		ix_vol					= 1,
		ix_damper				= 2,
		ix_pluck				= 3
	};
	enum {my_num_params = 4};
	enum {my_track = 0};
	samp vol;
	freq pitch;
	int buflen;
	int bufpos;
	float *buf;
	samp lastout;
	float damper;
	
	void SimpleString::pluck();
	static float scaledamper(float value);
public:
	SimpleString(machine *m);
	~SimpleString();
	static int SimpleString::initialize(machine_type* t);
	static void SimpleString::describe(char* dest, int which, param value);
	void SimpleString::update(int track, int which, param value);
	int SimpleString::work(int block_size);
	int SimpleString::track(int change);
};
